function [c1, success, Aql,k] = Log_SP_decode(L_rate,H,max_iter)
%%initialization
[m,l] = size(H); if m>l, H=H'; [m,l] = size(H); end
if ~issparse(H) % make H sparse if it is not sparse yet
   [ii,jj,sH] = find(H);
   H = sparse(ii,jj,sH,m,l);
end


% temptanhs=sparse(m,l);

[ii,jj] = find(H);            
indx = sub2ind([m l],ii,jj);
%iterations
k=0;
success = 0;
% max_iter = 20;
% Apl=log(f1./f0);
Apl=L_rate;
AA=H * spdiags(Apl(:),0,l,l);
Aq=AA;
while ((success == 0) & (k < max_iter)),
   k = k+1;
   Aqd2=Aq/2;
   ptanhs=spfun('tanh',Aqd2);
%    ptanhs(indx(ptanhs(indx)==0))=eps;
%    ptanhs=spfun('tanh',Aqd2);
   hpv= full(real(exp(sum(spfun('log',ptanhs),2))));
   hp=spdiags(hpv(:),0,m,m)*H;
   tem1=hp(indx)./ptanhs(indx);
   tem1(tem1<=-1)=eps-1;
   tem1(tem1>=1)=-eps+1;
%    tem2=log((1-tem1)./(1+tem1));
%    tem2=2*atan(tem1);
   tem2=log((1+tem1)./(1-tem1));
   Ar=sparse(ii,jj,tem2,m,l);

   BB=sum(Ar,1);
   Aql=Apl+BB;
   c1=1-sign(Aql);
   c1=round(c1/2);
   if sum(rem(H*(c1'),2)) == 0, success = 1; end   
   Aq=AA+H*spdiags(BB(:),0,l,l)-Ar;
%    Aql1=Apl+sum(H*spdiags(BB(:),0,l,l)-Ar,1);
end


