%%%%%%%%%%%%%% 20170918 RaptorеLTBER  %%%%%%%%%%%%%%
clear;clc;
tic;
format long
diary off  
rec_file='LT_AWGN_BEC_L1000_2000_ep0.txt';    % ¼̺ͽļ
if  exist(rec_file,'file')
    delete(rec_file);
end;
diary(rec_file); 

K=1000;
iter_num=50;
frame_num=500;
Es=1;

EbN0_vec=[0:0.5:6];
% sigma_0=0.5011
overhead_vec=[1.1:0.1:4];
N_vec=K*overhead_vec;
code_rate_vec=K./N_vec;


BER=zeros(length(overhead_vec),length(EbN0_vec));
PER=BER;

for overhead_index=1:length(overhead_vec)
    overhead=overhead_vec(overhead_index)
    N=round(K*overhead);
  for EbN0_index=1:length(EbN0_vec)
      EbN0=EbN0_vec(EbN0_index);
      Eb=Es/code_rate;
      N0=Eb/EbN0;
      sigma_0=sqrt(N0*Es/2);     % ׼
      
      
      
    frame_count=0;
    errbitnum=0;
    errframenum=0;
    G_LT=Raptor_encode_weak_distr(K,N);
    while frame_count<frame_num
        frame_count=frame_count+1;
        msg=randperm(K)>K/2;
        LT_code=mod(msg*G_LT,2);
        LT_rece=Es.*(1-2*LT_code)+sigma_0*randn(1,N);
        L_rate=2*Es./(sigma_0.^2).*LT_rece;
        [d_LT_msg,soft_LT_msg] = LT_soft_decode(L_rate,G_LT,iter_num);
        [num1,rat1]=biterr(d_LT_msg,msg);
        errbitnum=errbitnum+num1;
        errframenum=errframenum+(num1~=0);       
    end; % while frame_count<frame_num
    PER(overhead_index)=errframenum/frame_count
    BER(overhead_index)=errbitnum/(K*frame_count)
      frame_count
      
      
  end; %for EbN0_index=1:length(EbN0_vec)
end; %for overhead_index=1:length(overhead_vec)
toc;
diary off